/**
 * AJAX Nette Framework plugin for jQuery
 *
 * @copyright Copyright (c) 2009, 2010 Jan Marek
 * @copyright Copyright (c) 2009, 2010 David Grudl
 * @copyright Copyright (c) 2012 Vojtěch Dobeš
 * @license MIT
 *
 * @version 1.2.2
 */(function(e,t,n){if(typeof t!="function")return console.error("nette.ajax.js: jQuery is missing, load it please");var r=function(){var e={self:this,initialized:!1,contexts:{},on:{init:{},load:{},prepare:{},before:{},start:{},success:{},complete:{},error:{}},fire:function(){var r=!0,i=Array.prototype.slice.call(arguments),s=i.shift(),o=typeof s=="string"?s:s.name,u=typeof s=="object"?s.off||{}:{};i.push(e.self);t.each(e.on[o],function(s,o){if(o===n||t.inArray(s,u)!==-1)return!0;var a=o.apply(e.contexts[s],i);return r=a===n||a});return r},requestHandler:function(t){if(!e.self.ajax({},this,t))return},ext:function(r,i,s){while(!s){s="ext_"+Math.random();e.contexts[s]&&(s=n)}t.each(r,function(t,n){e.on[t][s]=n});e.contexts[s]=t.extend(i?i:{},{name:function(){return s},ext:function(t,n){var r=e.contexts[t];if(!r&&n)throw"Extension '"+this.name()+"' depends on disabled extension '"+t+"'.";return r}})}};this.ext=function(r,i,s){if(typeof r=="object")e.ext(r,i);else{if(i===n)return e.contexts[r];if(!i){t.each(["init","load","prepare","before","start","success","complete","error"],function(t,i){e.on[i][r]=n});e.contexts[r]=n}else{if(typeof r=="string"&&e.contexts[r]!==n)throw"Cannot override already registered nette-ajax extension '"+r+"'.";e.ext(i,s,r)}}return this};this.init=function(t,r){if(e.initialized)throw"Cannot initialize nette-ajax twice.";if(typeof t=="function"){this.ext("init",null);this.ext("init",{load:t},r)}else if(typeof t=="object"){this.ext("init",null);this.ext("init",t,r)}else if(t!==n)throw"Argument of init() can be function or function-hash only.";e.initialized=!0;e.fire("init");this.load();return this};this.load=function(){e.fire("load",e.requestHandler);return this};this.ajax=function(r,i,s){if(!r.nette&&i&&s){var o=t(i),u,a,f=r.nette={e:s,ui:i,el:o,isForm:o.is("form"),isSubmit:o.is("input[type=submit]")||o.is("button[type=submit]"),isImage:o.is("input[type=image]"),form:null};f.isSubmit||f.isImage?f.form=f.el.closest("form"):f.isForm&&(f.form=f.el);r.url||(r.url=f.form?f.form.attr("action"):i.href);r.type||(r.type=f.form?f.form.attr("method"):"get");if(o.is("[data-ajax-off]")){var l=o.attr("data-ajax-off");l.indexOf("[")===0?r.off=o.data("ajaxOff"):l.indexOf(",")!==-1?r.off=l.split(","):l.indexOf(" ")!==-1?r.off=l.split(" "):r.off=l;typeof r.off=="string"&&(r.off=[r.off]);r.off=t.grep(t.each(r.off,function(e){return t.trim(e)}),function(e){return e.length})}}e.fire({name:"prepare",off:r.off||{}},r);r.prepare&&r.prepare(r);a=r.beforeSend;r.beforeSend=function(t,r){var i=e.fire({name:"before",off:r.off||{}},t,r);(i||i===n)&&a&&(i=a(t,r));return i};return this.handleXHR(t.ajax(r),r)};this.handleXHR=function(t,n){n=n||{};if(t&&(typeof t.statusText=="undefined"||t.statusText!=="canceled")){t.done(function(t,r,i){e.fire({name:"success",off:n.off||{}},t,r,i,n)}).fail(function(t,r,i){e.fire({name:"error",off:n.off||{}},t,r,i,n)}).always(function(t,r){e.fire({name:"complete",off:n.off||{}},t,r,n)});e.fire({name:"start",off:n.off||{}},t,n);n.start&&n.start(t,n)}return t}};t.nette=new(t.extend(r,t.nette?t.nette:{}));t.fn.netteAjax=function(e,n){return t.nette.ajax(n||{},this[0],e)};t.fn.netteAjaxOff=function(){return this.off(".nette")};t.nette.ext("validation",{before:function(e,r){if(!r.nette)return!0;var i=r.nette,s=i.e,o=t.extend({keys:!0,url:!0,form:!0},r.validate||function(){if(!i.el.is("[data-ajax-validate]"))return;var e=i.el.data("ajaxValidate");if(e===!1)return{keys:!1,url:!1,form:!1};if(typeof e=="object")return e}()||{}),u=!1;if(i.el.attr("data-ajax-pass")!==n){u=i.el.data("ajaxPass");u=typeof u=="bool"?u:!0}if(o.keys){var a=s.button||s.ctrlKey||s.shiftKey||s.altKey||s.metaKey;if(i.form){if(a&&i.isSubmit){this.explicitNoAjax=!0;return!1}if(i.isForm&&this.explicitNoAjax){this.explicitNoAjax=!1;return!1}}else if(a)return!1}if(o.form&&i.form&&(!i.isSubmit&&!i.isImage||i.el.attr("formnovalidate")===n)&&i.form.get(0).onsubmit&&i.form.get(0).onsubmit(s)===!1){s.stopImmediatePropagation();s.preventDefault();return!1}if(o.url&&/:|^#/.test(i.form?r.url:i.el.attr("href")))return!1;if(!u){s.stopPropagation();s.preventDefault()}return!0}},{explicitNoAjax:!1});t.nette.ext("forms",{init:function(){var t;if(!e.Nette||!(t=this.ext("snippets")))return;t.after(function(t){t.find("form").each(function(){e.Nette.initForm(this)})})},prepare:function(e){var n=e.nette;if(!n||!n.form)return;var r=n.e,i=e.data||{},s={};if(n.isSubmit)s[n.el.attr("name")]=n.el.val()||"";else if(n.isImage){var o=n.el.offset(),u=n.el.attr("name"),a=[Math.max(0,r.pageX-o.left),Math.max(0,r.pageY-o.top)];if(u.indexOf("[",0)!==-1)s[u]=a;else{s[u+".x"]=a[0];s[u+".y"]=a[1]}}typeof i!="string"&&(i=t.param(i));s=t.param(s);e.data=n.form.serialize()+(s?"&"+s:"")+"&"+i}});t.nette.ext("snippets",{success:function(e){var n=[],r=[];if(e.snippets){for(var i in e.snippets){var s=this.getElement(i);s.get(0)&&r.push(s.get(0));t.each(this.beforeQueue,function(e,t){typeof t=="function"&&t(s)});this.updateSnippet(s,e.snippets[i]);t.each(this.afterQueue,function(e,t){typeof t=="function"&&t(s)})}var o=t(r).promise();t.each(this.completeQueue,function(e,t){typeof t=="function"&&o.done(t)})}}},{beforeQueue:[],afterQueue:[],completeQueue:[],before:function(e){this.beforeQueue.push(e)},after:function(e){this.afterQueue.push(e)},complete:function(e){this.completeQueue.push(e)},updateSnippet:function(e,t,n){typeof e=="string"&&(e=this.getElement(e));e.is("title")?document.title=t:this.applySnippet(e,t,n)},getElement:function(e){return t("#"+this.escapeSelector(e))},applySnippet:function(e,t,n){!n&&e.is("[data-ajax-append]")?e.append(t):e.html(t)},escapeSelector:function(e){return e.replace(/[\!"#\$%&'\(\)\*\+,\.\/:;<=>\?@\[\\\]\^`\{\|\}~]/g,"\\$&")}});t.nette.ext("redirect",{success:function(t){if(t.redirect){e.location.href=t.redirect;return!1}}});t.nette.ext("state",{success:function(e){e.state&&(this.state=e.state)}},{state:null});t.nette.ext("unique",{start:function(e){this.xhr&&this.xhr.abort();this.xhr=e},complete:function(){this.xhr=null}},{xhr:null});t.nette.ext("abort",{init:function(){t("body").keydown(t.proxy(function(e){this.xhr&&e.keyCode.toString()==="27"&&!(e.ctrlKey||e.shiftKey||e.altKey||e.metaKey)&&this.xhr.abort()},this))},start:function(e){this.xhr=e},complete:function(){this.xhr=null}},{xhr:null});t.nette.ext("load",{success:function(){t.nette.load()}});t.nette.ext("init",{load:function(e){t(this.linkSelector).off("click.nette",e).on("click.nette",e);t(this.formSelector).off("submit.nette",e).on("submit.nette",e).off("click.nette",":image",e).on("click.nette",":image",e).off("click.nette",":submit",e).on("click.nette",":submit",e);t(this.buttonSelector).closest("form").off("click.nette",this.buttonSelector,e).on("click.nette",this.buttonSelector,e)}},{linkSelector:"a.ajax",formSelector:"form.ajax",buttonSelector:'input.ajax[type="submit"], button.ajax[type="submit"], input.ajax[type="image"]'})})(window,window.jQuery);